#ifndef DEVICES_PRTGFX_H
#define DEVICES_PRTGFX_H
/*
** $Filename: devices/prtgfx.h $
** $Release: 2.04 Includes, V37.4 $
** $Revision: 1.12 $
** $Date: 90/07/26 $
**
** printer.device structure definitions
**
** (C) Copyright 1987-1991 Commodore-Amiga, Inc.
** All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include "exec/types.h"
#endif

#define PCMYELLOW 0 
#define PCMMAGENTA 1 
#define PCMCYAN 2 
#define PCMBLACK 3 
#define PCMBLUE PCMYELLOW 
#define PCMGREEN PCMMAGENTA 
#define PCMRED PCMCYAN 
#define PCMWHITE PCMBLACK 

union colorEntry {
 ULONG colorLong; 
 UBYTE colorByte[4]; 
 BYTE colorSByte[4]; 
};

struct PrtInfo { 
 int (*pi_render)(); 
 struct RastPort *pi_rp; 
 struct RastPort *pi_temprp; 
 UWORD *pi_RowBuf; 
 UWORD *pi_HamBuf; 
 union colorEntry *pi_ColorMap; 
 union colorEntry *pi_ColorInt; 
 union colorEntry *pi_HamInt; 
 union colorEntry *pi_Dest1Int; 
 union colorEntry *pi_Dest2Int; 
 UWORD *pi_ScaleX; 
 UWORD *pi_ScaleXAlt; 
 UBYTE *pi_dmatrix; 
 UWORD *pi_TopBuf; 
 UWORD *pi_BotBuf; 

 UWORD pi_RowBufSize; 
 UWORD pi_HamBufSize; 
 UWORD pi_ColorMapSize; 
 UWORD pi_ColorIntSize; 
 UWORD pi_HamIntSize; 
 UWORD pi_Dest1IntSize; 
 UWORD pi_Dest2IntSize; 
 UWORD pi_ScaleXSize; 
 UWORD pi_ScaleXAltSize; 

 UWORD pi_PrefsFlags; 
 ULONG pi_special; 
 UWORD pi_xstart; 
 UWORD pi_ystart; 
 UWORD pi_width; 
 UWORD pi_height; 
 ULONG pi_pc; 
 ULONG pi_pr; 
 UWORD pi_ymult; 
 UWORD pi_ymod; 
 WORD pi_ety; 
 UWORD pi_xpos; 
 UWORD pi_threshold; 
 UWORD pi_tempwidth; 
 UWORD pi_flags; 
};

#endif 
